/*Ŀ
 ݳ                                                                      
 ݳ Program Name: COMPRESS.PRG      Copyright: None                      
 ݳ Date Created: 12/22/95           Language: Clipper 5.3               
 ݳ Time Created: 10:33:39             Author: Kevin S Gallagher         
 Ĵ
 ݳ                                                                      
 ݳ                                                                      
 ݳ                                                                      
 ݳ                                                                      
 
            */

#include "Directry.ch"
#include "include1.h"


#xtranslate NtoS(<n>) => ltrim(str(<n>))

/*
*   Routine: kg_compress(<cFile>,<cMemo>)
*          : 
*   Purpose: Archive databases into a archive data system
*          : 
* Arguments: <cFile> is the name of a database to archive
*          : <cMemo> is the name of a associated memo file for <cFile>
*          : 
*          : 
*  Comments: If someone attempts to backup the backup file to itself
*          : this routine simply returns to the caller.
*          : 
*          : Upon entry, it is not known if <cMemo> file actually exist
*          : 
*/
procedure kg_compress(cFile,cMemo)
    field dbfname
    local aSpecs_

    if cFile == "BACKUPS.DBF"
        return                                          /* NOTE */
    endif

    if !file("backups.dbf")
        // if not done you wish you had
        if file("back1" + indexext())
            ferase("back1" + indexext())
        endif
        MakeBack()
    endif

    use backups new via "DBFMEMO"
    if neterr()
        // Recovery
    endif

    if !file("back1" + indexext())
        index on dbfname to back1
    else
        set index to back1
    endif

    if backups->(dbseek(cFile))
        /*
        * Here we simply bypass updating if the file is already
        * in backup file. If it is already in the backup file
        * then i suggest querying the user with date/time stamps
        * to either replace the current file or bypass the operation
        */
        alert(cFile + " is already in archive")
    else
        ?"Adding ",cFile
        aSpecs_ := directory(cFile)
        backups->(dbappend())
        backups->dbfname := cFile
        backups->dbftime := aSpecs_[1,F_TIME]
        backups->dbfdate := aSpecs_[1,F_DATE]

        blobimport(N_DBFNAME,cFile)
        if file(cMemo)
            ??"  " + cMemo
            backups->dbtname := cMemo
            blobimport(N_DBTNAME,cMemo)
        endif
    endif

    backups->(dbclosearea())
return

/*
*   Routine: Makeback
*          : 
*   Purpose: used to create archive database if not present
*          : 
*  Comments: Void
*          : 
*/
static procedure MakeBack
    dbcreate("backups"             ,;
        {                           ;
            {"dbfname  ","C",13,0} ,;
            {"dbffile  ","M",10,0} ,;
            {"dbtname  ","C",13,0} ,;
            {"dbtfile  ","M",10,0} ,;
            {"dbftime  ","C", 8,0} ,;
            {"dbfdate  ","D", 8,0}  ;
        } ;
    )
return

