/*Ŀ
 ݳ                                                                      
 ݳ Program Name: ERRORSYS.PRG      Copyright: OR Dept. of Revenue       
 ݳ                                  Language: Clipper 5.3               
 ݳ                                   Tweaker: Kevin S. Gallagher        
 Ĵ
 ݳ This is a modified version of errorsys that creates (if not found)   
 ݳ a textfile for recording runtime error information. I elected not to 
 ݳ record awhole lot of information, just the basic facts. Note that i  
 ݳ trimmed the modified version down so that no external libraries are  
 ݳ required (i used nanfor and grump libraries). There is self-checks   
 ݳ to prevent recursive errors in deferr() in the event someone makes a 
 ݳ BooBoo within this program file.                                     
 ݳ                                                                      
 ݳ If running in graphic mode i suggest replacing all occurances of the 
 ݳ alert() with one that allows multiple lines with semi-colons which   
 ݳ is not all that hard to do :-)                                       
 
 
*/


/***
*
*	Errorsys.prg
*
*  Standard Clipper error handler
*
*  Copyright (c) 1990-1993, Computer Associates International, Inc.
*  All rights reserved.
*
*  Compile:  /m /n /w /es2
*
*/

#include "llibg.ch"
#include "fileio.ch"
#include "error.ch"


#command ? <list,...>   =>  ?? Chr(13) + Chr(10) ; ?? <list>
#command ?? <list,...>  =>  OutErr(<list>)

#xtranslate ifnone( <x> )               =>      ;
    if(empty( <x> ), "<none>", <x> )

#define CRLF chr(13) + chr(10)

#xtranslate FWriteLine( <string> )      =>      ;
    fwrite(nhandle, <string> + CRLF )

#xtranslate NtoS( <n> )                 =>      ;
   ltrim( str( <n> ) )

#define ERR_PRN_BUTS                            ;
    {"Retry","Break","File","Quit"}

#define ERROR_LOGFILE                           ;
    "C:\ERRORLOG.TXT"

/*
*   Routine: ErrorSystem()
*          :
*   Purpose:
*          :
* Arguments:
*          :
*  Comments: automatically executes at startup
*          :
*/
procedure ErrorSys()
	ErrorBlock( {|e| DefError(e)} )
return

/*
*   Routine: DefaultError(<e>)
*          :
*   Purpose: exception handler
*          :
* Arguments: <e> error object
*          :
*  Comments: If using 5.3 Clipper in graphic mode, added code
*          : will be required to go back to text mode.
*          :
*/
static function DefError(e)
    local i
    local cMessage
    local aOptions
    local nChoice
    local aInfo_
    local aArgs_
    local xCargo

    if (IsLooping(procname(), 2))
        alert("Recursive error in DefErr"); ErrorInHandler()
    endif

    while ( dispcount() > 0)
        dispend()
    enddo

    if e:genCode == EG_PRINT
        return PrintError()
    endif

	if (e:genCode == EG_ZERODIV)
		return (0)
    endif

	if (e:genCode == EG_OPEN .and. e:osCode == 32 .and. e:canDefault)
		NetErr(.t.)
		return (.f.)
    endif

	if (e:genCode == EG_APPENDLOCK .and. e:canDefault)
		NetErr(.t.)
        return (.f.)
    endif

	cMessage := ErrorMessage(e)

	if ( !Empty(e:osCode))
        cMessage += " (DOS Error " + NtoS(e:osCode) + ") "
    endif

    aInfo_ := {}
    aadd( aInfo_,cMessage )
    aArgs_ := GetErrArgs(e)
    aadd(aInfo_,aArgs_[1])
    aadd(aInfo_,aArgs_[2])
    aadd(aInfo_, "" )
    aadd(aInfo_,"TraceBack")
    aadd(aInfo_,replicate(chr(45),77))

	i := 2
    while ( !Empty(ProcName(i)) )
        // exclude known routines
        if procname(i) != "LOCKERRHAN" .and. procname(i) != "(b)INITHANDL$"
            aadd(aInfo_,Trim(ProcName(i)) + "(" + NtoS(ProcLine(i)) + ")  ")
        endif
        i++
    enddo

    if len(aInfo_) > 0
        LogNewErr(aInfo_)
    endif

    setcursor(0)
    * setmode(25)
    setcursor(1)
    setcolor("w/n")
    @maxrow(),0

    if row() < maxrow() -2
        setpos(row() +1,0)
    endif

    alert("Error has been written to;" + ERROR_LOGFILE)
    SET VIDEOMODE TO LLG_VIDEO_TXT
    cls

	errorlevel(1)
	QUIT

return (.f.)


/***
*	ErrorMessage()
*/
static func ErrorMessage(e)
    local cMessage

	cMessage := if(e:severity > ES_WARNING, "Error ", "Warning ")

	if (valtype(e:subsystem) == "C")
		cMessage += e:subsystem()
	else
		cMessage += "???"
    endif

	if (valtype(e:subCode) == "N")
		cMessage += ("/" + NtoS(e:subCode))
	else
		cMessage += "/???"
    endif

    if (valtype(e:description) == "C")
        cMessage += ("  " + e:description)
    endif

    if (!empty(e:filename))
        cMessage += (": " + e:filename)
    elseif ( ! empty(e:operation))
        cMessage += (": " + e:operation)
    endif

return (cMessage)

/*
*   Routine: LogNewErr( <aInfo> )
*          :
*   Purpose: Write runtime error info to disk logfile
*          :
* Arguments: <aInfo_> Description of error and program traceback
*          :
*  Comments: void
*/
static procedure LogNewErr( aInfo_ )
    local nHandle
    local lFlag := .t.
    local nArrLen
    local jj
    local aEnv_
    local nLenEnv

    if (IsLooping(procname(), 2))
        alert("Recursive error in LogNewErr()",{"Quit"}); ErrorInHandler()
    endif

    nArrLen := len(aInfo_)

    if file(ERROR_LOGFILE)
        nHandle := fopen(ERROR_LOGFILE,FO_READWRITE)
        lFlag   := if(nHandle < 5,.f.,.t.)
    else
        nHandle := fcreate(ERROR_LOGFILE)
        lFlag   := if(nHandle == F_ERROR,.f.,.t.)
    endif

    if lFlag .and. nArrLen != NIL
        fseek(nHandle,0,FS_END)
        FWriteLine("")
        FWriteLine(":BEGIN")
        FWriteLine("        Date: " + dtoc(date()))
        FWriteLine("        Time: " + time())
        * FWriteLine("     AppName: " + ft_origin())
        FWriteLine("  Reg memory: " + NtoS(memory(0)) + "k")
        FWriteLine("  EMS memory: " + NtoS(memory(4)) + "k")
        FWriteLine("  Console is: " + if(set(_SET_CONSOLE),"On","Off"))
        FWriteLine("  Printer is: " + if(set(_SET_PRINTER),"On","Off"))
        * FWriteLine(" LPT1 status: " + "is " + LPT_Status(1))
        * FWriteLine(" LPT2 status: " + "is " + LPT_Status(2))
        * FWriteLine(" LPT3 status: " + "is " + LPT_Status(3))
        FWriteLine("   Device is: " + WhichDevice())

        FWriteLine("")

        for jj := 1 to nArrLen
            FWriteLine(aInfo_[jj])
        next

        FWriteLine(":END")

        if ! fclose(nHandle)
            alert("ERROR: closing error logfile")
        endif
    else
        alert("ERROR: Written to errorfile;Contact system support",{"Quit"})
    endif
return

/*
*   Routine: KG_PushError( <aInfo_> )
*          :
*   Purpose: write error info without quiting
*          :
* Arguments: array of character strings to write into the error file
*          :
*  Comments: 
*          :
*/
procedure KG_PushError( aInfo_ )
    local nHandle
    local lFlag := .t.
    local nArrLen
    local jj
    local aEnv_
    local nLenEnv

    if (IsLooping(procname(), 2))
        alert("Recursive error in KG_PushError()",{"Quit"})
        ErrorInHandler()
    endif

    nArrLen := len(aInfo_)

    if file(ERROR_LOGFILE)
        nHandle := fopen(ERROR_LOGFILE,FO_READWRITE + FO_EXCLUSIVE)
        lFlag   := if(nHandle < 5,.f.,.t.)
    else
        nHandle := fcreate(ERROR_LOGFILE,FC_NORMAL)
        lFlag   := if(nHandle == F_ERROR,.f.,.t.)
    endif

    if ferror() != 0
        alert("FATAL ERROR;failed to write to ;" +            ;
              ERROR_LOGFILE + ";"                +            ;
             "Routine "     + lower(procname())  +            ;
             "/" + NtoS(procline())                           ;
        )
        return
    endif

    if lFlag .and. nArrLen != NIL
        fseek(nHandle,0,FS_END)
        FWriteLine("")
        FWriteLine(":BEGIN")
        FWriteLine("      Date: " + dtoc(date()))
        FWriteLine("      Time: " + time())
        * FWriteLine("   AppName: " + ft_origin())
        FWriteLine("")

        for jj := 1 to nArrLen
            FWriteLine(aInfo_[jj])
        next

        FWriteLine(":END")

        if ! fclose(nHandle)
            alert("ERROR: closing error logfile;"            +;
                  ERROR_LOGFILE                               ;
            )
        else
            alert("ALERT; Error information recorded to;"    +;
                  + ERROR_LOGFILE + ";"                      +;
                  "Please notify system support"              ;
            )
        endif
    else
        alert("ERROR: Written to error logfile;" + ERROR_LOGFILE)
    endif
return

static procedure ErrTone()
    tone(440,1)
    tone(440,1)
return

/*
*      Function: PrintError
*              :
*   Description: Allows alternate recovery from printer errors
*              :
*        Author: Kevin S. Gallagher
*              :
*     Arguments: None
*              :
*  Return Value: None
*              :
*      See Also: DefErr()
*              :
*      Comments: Allows printing to text files, so that lengthy print
*              : jobs do not have to be re-issued. Hopefully there is
*              : no problem written report to disk, ie. no-rights or
*              : disk is bad etc.
*              :
*              : If the user presses enter w/o entering a filename the
*              : filename is made up from a time string.
*              :
*/
static function PrintError
    local cScreen
    local getlist := {}
    local cFile   := space(8)
    local lRetVal := .f.
    local nChoice := 0
    local nOldRow := row()
    local nOldCol := col()
    local nCursor := setcursor()
    local cDevice := set(_SET_DEVICE, "SCREEN")
    local lPrint  := set(_SET_PRINTER, .f.)

    if (IsLooping(procname(), 2))
        alert("Recursive error in PrintError()",{"Quit"}); ErrorInHandler()
    endif

    while nChoice == 0
        ErrTone()
        nChoice := alert("The printer is not responding!", ERR_PRN_BUTS)
    enddo

    do case
        case nChoice == 1
            lRetVal := .t.
        case nChoice == 3
            cScreen := savescreen(0,0,2,maxcol())
            dispbox(0,0,2,maxcol(),'ͻȺ ',"n/r")
            @1, 2 say "Enter filename:"                        color "w+/r"
            @1,27 say "or press ENTER to generate random name" color "w+/r"
            @1,18 get cFile                                    color "w/n"
            setcursor(1)
            read
            setcursor(nCursor)
            restscreen(0,0,2,maxcol(),cScreen)
            cFile := alltrim(cFile)
            cFile := strtran(cFile,chr(32),chr(95))
            if empty(cFile)
                cFile := strtran(time(),":","")
            endif
            //
            // The path is the current directory, which may or may not
            // create a problem, ie. disk errors, network right errors
            // So i create the printfile on the root of C and hope the
            // drive is ready!
            //
            alert("The filename will be;" + cFile + ".PRN")

            set(_SET_PRINTFILE, "C:\"+cFile)
            lRetVal := .t.
        case nChoice == 4
            quit
    endcase

    setpos(nOldRow, nOldCol)
    set(_SET_DEVICE, cDevice)
    set(_SET_PRINTER, lPrint)

    if nChoice == 2
        break
    endif

return (lRetVal)

/*
*   Routine: IsLooping( <cName>, <nTimes> ) --> L
*          :
*   Purpose: See if caller is in a recursive loop
*          :
* Arguments: <cName>   Calling routine
*          :
*          : <nTimes>  Max calls to caller
*          :
*  Comments: Recovery example, from caller
*          :
*          : if (IsLooping(procname(), 3))
*          :    setpos(maxrow() -1, maxcol())
*          :    outerr(Chr(13) + Chr(10))
*          :    outerr("Recursion Depth Exceeded")
*          :    errorlevel(1)
*          :    quit
*          : endif
*          :
*          :
*/
function IsLooping(cName, nTimes)
    local nVarOne := 0, nVarTwo := 1
    while (!Empty(procname(nVarTwo)))
        if (procname(nVarTwo) == cName)
            nVarOne++
        endif
        nVarTwo++
    enddo
return (nVarOne > nTimes)

/*
*   Routine: GetErrArgs( <e> ) --> A
*          :
*   Purpose: Setup argument info for error logfile
*          :
* Arguments: <e>   error object
*          :
*  Comments: used internally by Deferr()
*          :
*/
function GetErrArgs(e)
    local cArgStr
    local xArgCnt
    if valtype(e:args) == "A"
        cArgStr := ""
        aeval(e:args, {|s| cArgStr += (ft_xtoy(s,"C") +", ")} )
        cArgStr := left(cArgStr, min(len(cArgStr) -2, 35))
        xArgCnt := NtoS(len(e:args))
    else
        cArgStr := "<none>"
        xArgCnt := "0"
    endif
return { "  Arguments: " + cArgStr, "  Arg Count: " + xArgCnt, "" }

/*
*   Routine: LPT_Status(<nPort>)
*          :
*   Purpose: Used to write status of LPT ports to error logfile.
*          :
* Arguments: <nPort> LPT1/LPT2/LPT3
*          :
*  Comments: It is possible for some computers to return .T. even if
*          : no printer is attached. Also if on Novell, the operating
*          : system might tell us the printer is ready but if the 
*          : application has a invalid queue, or its corrupt we really
*          : do not positively know if the port failed or the queue.
*          :
*/
static function LPT_Status(nPort)
    local cPort   := NtoS(nPort)
    local cString := "LPT" + cPort
    cString := "Requires Nanfor.lib"
    * cString += if( ft_isprint("LPT" + cPort),""," Not") + " Ready"
return  cString

/*
*   Routine: WhichDevice()
*          :
*   Purpose:
*          :
* Arguments:
*          :
*  Comments:
*          :
*/
static function WhichDevice()
return lower( ft_xtoy( set(_SET_DEVICE),"C") )


