/*Ŀ
 ݳ                                                                      
 ݳ Program Name: TAGTEST.PRG       Copyright: None                      
 ݳ Date Created: 12/22/95           Language: Clipper 5.3 or higher     
 ݳ Time Created: 10:05:41             Author: Kevin S Gallagher         
 Ĵ
 ݳ The original demo was created by Nicholas Solomon, and has been      
 ݳ done over to show how to collect files on disk to be placed into     
 ݳ 5.3 Clipper's FlexFile fields                                        
 ݳ                                                                      
 
            */


#include "tagbrow.ch"

/*
* Change according to the RDD being used
*/
#define C_MEMO_TYPE "DBT"

field dbfname


/*
*   Routine: main
*          : 
*   Purpose: shows how to archive diskfiles into memo fields
*          : 
*  Comments: For this demo to work there must be one or more
*          : database files in the runtime working directory.
*          : It would be nice to have some databases that 
*          : also have thier memo files available!
*          : 
*/
function MakeTag()
    local x
    local nLen
    local cMemo
    local cFile
    local aRecs_ := {}
    local aFiles_ := directory("*.DBF")
    local cScrn
    local nCursor := setcursor(0)

    if empty(nLen := len(aFiles_))
        alert("No files;Please quit demo and get some databases")
        return nil
    endif

    cScrn := savescreen()

	dbcreate("TAGBROW.DBF",{{"DBFname","C",15,0}})
    use tagbrow alias tag exclusive new
    if neterr()
        // Place recovery code here!
    endif

    index on DBFname to dbfnames

    for x := 1 to nLen
        tag->(dbappend())
		tag->DBFname := aFiles_[x,1]
    next

	tag->(dbgotop())

	cls
	// now make call to tagbrow
    create tagbrowse array aRecs_                   ;
        usefield 'DBFname'                          ;
        top 5                                       ;
        left 20                                     ;
        colname 'SELECT'                            ;
    title 'F1=Help' message

	// now display the contents of the selected items
	cls

    if !empty(nLen := len(aRecs_))
        for x := 1 to nLen
            tag->(dbgoto(aRecs_[x]))
            cFile := rtrim(tag->DBFname)
            cMemo := strtran(cFile,"DBF",C_MEMO_TYPE)
            kg_compress(cFile,cMemo)
        next
    endif

    if row() >0
        wait "Press any key for main menu..."
    endif

	tag->(dbclosearea())

    ferase('TAGBROW.DBF')
    ferase("dbfnames" + indexext())

    restscreen(0,0,maxrow(),maxcol(),cScrn)
    setcursor(nCursor)
return (nil)

function ShowArchs
    local cScrn := savescreen()
    local nCursor := setcursor(0)
    use backups new alias demo exclusive
    if neterr()
        // Place recovery code here!
    endif
    index on dbfname to back1

    demo->(ViewNames())
    demo->(dbclosearea())

    restscreen(0,0,maxrow(),maxcol(),cScrn)
    setcursor(nCursor)
return nil


/*
*   Routine: Kg_Help()
*          : 
*   Purpose: Hook into tag-browse -> setkey
*          : 
*  Comments: void
*          : 
*/
procedure kg_Help
    alert("Place your help here")
return

